<?php
/**
 * This Software is the property of Data Development and is protected
 * by copyright law - it is NOT Freeware.
 * Any unauthorized use of this software without a valid license
 * is a violation of the license agreement and will be prosecuted by
 * civil and criminal law.
 * http://www.shopmodule.com
 *
 * @copyright (C) D3 Data Development (Inh. Thomas Dartsch)
 * @author        D3 Data Development - <support@shopmodule.com>
 * @link          http://www.oxidmodule.com
 */

if (false == function_exists("getShopBasePath")) {
    /**
     * Returns shop base path.
     *
     * @return string
     */
    function getShopBasePath()
    {
        return realpath(dirname(__FILE__) . '/../../../..') . '/';
    }
}

include_once getShopBasePath() . "bootstrap.php";


define('sWatermarkModulePath', getShopBasePath() . "modules/d3/d3watermark/");
include_once sWatermarkModulePath . "models/d3watermark_activeCheck_forShop.php";

$oD3wmAc = oxNew('d3watermark_activeCheck_forShop');

if ($oD3wmAc->isModuleActiveInShop()) {
    if (false == function_exists("getGeneratorInstanceName")) {
        /**
         * @return string
         */
        function getGeneratorInstanceName()
        {
            return "d3_oxdynimggenerator_watermark";
        }
    }

    // checks if image utils file loader does not exist
    if (false == function_exists("includeImageUtils")) {
        /**
         * Includes image utils
         *
         * @return null
         */
        function includeImageUtils()
        {
            include_once sWatermarkModulePath . "core/utils/d3_oxpicgenerator_watermark.php";
        }
    }
}

include_once getShopBasePath() . "core/oxdynimggenerator.php";

if ($oD3wmAc->isModuleActiveInShop()) {
    /**
     * Class d3_oxdynimggenerator_watermark
     */
    class d3_oxdynimggenerator_watermark extends oxdynimggenerator
    {
        public function __construct()
        {
            if (method_exists(get_parent_class(), '__construct')) {
                parent::__construct();
            }

            if (strtolower(oxRegistry::getConfig()->getEdition()) == 'ee') {

                $oD3wmAc    = oxNew('d3watermark_activeCheck_forShop');
                $iNewShopId = $oD3wmAc->getWatermarkActiveShopId();

                if (false !== $iNewShopId) {
                    $oD3wmAc->d3ChangeToShop($iNewShopId);
                }

                /** @var $oModule oxmodule */
                $oModule = oxNew('oxmodule');

                if ($oModule->load('d3watermark') && $oModule->isActive()) {
                    $this->_aConfParamToPath = $oD3wmAc->getWatermarkConfParamsToPath();
                }
            }
        }
    }
}
